# misc_gui.cpp File Reference

GUIs for a number of misc windows. More...

`#include "stdafx.h"`
`#include "debug.h"`
`#include "landscape.h"`
`#include "newgrf_text.h"`
`#include "gui.h"`
`#include "viewport_func.h"`
`#include "gfx_func.h"`
`#include "command_func.h"`
`#include "company_func.h"`
`#include "town.h"`
`#include "string_func.h"`
`#include "company_base.h"`
`#include "texteff.hpp"`
`#include "company_manager_face.h"`
`#include "strings_func.h"`
`#include "zoom_func.h"`
`#include "window_func.h"`
`#include "querystring_gui.h"`
`#include "console_func.h"`
`#include "core/geometry_func.hpp"`
`#include "newgrf_debug.h"`
`#include "table/strings.h"`

Go to the source code of this file.

## Data Structures
class | LandInfoWindow
struct | AboutWindow
struct | ErrmsgWindow
| Window class for displaying an error message window. More...
struct | TooltipsWindow
| Window for displaying a tooltip. More...
struct | QueryStringWindow
| Class for the string query window. More...
struct | QueryWindow
| Window used for asking the user a YES/NO question. More...
## Defines
#define | LANDINFOD_LEVEL 1
## Enumerations
enum | LandInfoWidgets { LIW_BACKGROUND }
| Widgets for the land info window. More...
enum | AboutWidgets { AW_SCROLLING_TEXT, AW_WEBSITE }
| Widgets for the land info window. More...
enum | ErrorMessageWidgets { EMW_CAPTION, EMW_FACE, EMW_MESSAGE }
| Widgets of the error message windows.
enum | QueryStringWidgets { QUERY_STR_WIDGET_CAPTION, QUERY_STR_WIDGET_TEXT, QUERY_STR_WIDGET_DEFAULT, QUERY_STR_WIDGET_CANCEL, QUERY_STR_WIDGET_OK }
| Widget of the string query window. More...
enum | QueryWidgets { QUERY_WIDGET_CAPTION, QUERY_WIDGET_TEXT, QUERY_WIDGET_NO, QUERY_WIDGET_YES }
## Functions
bool | GetClipboardContents (char *buffer, size_t buff_len)
| Try to retrive the current clipboard contents.
void | ShowLandInfo (TileIndex tile)
| Show land information window.
void | ShowAboutWindow ()
void | ShowErrorMessage (StringID summary_msg, StringID detailed_msg, WarningLevel wl, int x, int y)
| Display an error message in a window.
void | ShowEstimatedCostOrIncome (Money cost, int x, int y)
| Display estimated costs.
void | ShowCostOrIncomeAnimation (int x, int y, int z, Money cost)
| Display animated income or costs on the map.
void | ShowFeederIncomeAnimation (int x, int y, int z, Money cost)
| Display animated feeder income.
TextEffectID | ShowFillingPercent (int x, int y, int z, uint8 percent, StringID string)
| Display vehicle loading indicators.
void | UpdateFillingPercent (TextEffectID te_id, uint8 percent, StringID string)
| Update vehicle loading indicators.
void | HideFillingPercent (TextEffectID *te_id)
| Hide vehicle loading indicators.
void | GuiShowTooltips (Window *parent, StringID str, uint paramcount, const uint64 params[], TooltipCloseCondition close_tooltip)
| Shows a tooltip.
static void | DelChar (Textbuf *tb, bool backspace)
bool | DeleteTextBufferChar (Textbuf *tb, int delmode)
| Delete a character from a textbuffer, either with 'Delete' or 'Backspace' The character is delete from the position the caret is at.
void | DeleteTextBufferAll (Textbuf *tb)
| Delete every character in the textbuffer.
bool | InsertTextBufferChar (Textbuf *tb, WChar key)
| Insert a character to a textbuffer.
bool | InsertTextBufferClipboard (Textbuf *tb)
| Insert a chunk of text from the clipboard onto the textbuffer.
bool | MoveTextBufferPos (Textbuf *tb, int navmode)
| Handle text navigation with arrow keys left/right.
void | InitializeTextBuffer (Textbuf *tb, char *buf, uint16 max_bytes, uint16 max_pixels)
| Initialize the textbuffer by supplying it the buffer to write into and the maximum length of this buffer.
void | InitializeTextBuffer (Textbuf *tb, char *buf, uint16 max_bytes, uint16 max_chars, uint16 max_pixels)
| Initialize the textbuffer by supplying it the buffer to write into and the maximum length of this buffer.
void | UpdateTextBufferSize (Textbuf *tb)
| Update Textbuf type with its actual physical character and screenlength Get the count of characters in the string as well as the width in pixels.
bool | HandleCaret (Textbuf *tb)
void | ShowQueryString (StringID str, StringID caption, uint maxsize, uint maxwidth, Window *parent, CharSetFilter afilter, QueryStringFlags flags)
| Show a query popup window with a textbox in it.
void | ShowQuery (StringID caption, StringID message, Window *parent, QueryCallbackProc *callback)
| Show a modal confirmation window with standard 'yes' and 'no' buttons The window is aligned to the centre of its parent.
## Variables
int | _caret_timer
static const NWidgetPart | _nested_land_info_widgets []
static const WindowDesc | _land_info_desc (WDP_AUTO, 0, 0, WC_LAND_INFO, WC_NONE, 0, _nested_land_info_widgets, lengthof(_nested_land_info_widgets))
static const NWidgetPart | _nested_about_widgets []
static const WindowDesc | _about_desc (WDP_CENTER, 0, 0, WC_GAME_OPTIONS, WC_NONE, 0, _nested_about_widgets, lengthof(_nested_about_widgets))
static const char *const | _credits []
static const NWidgetPart | _nested_errmsg_widgets []
static const WindowDesc | _errmsg_desc (WDP_MANUAL, 0, 0, WC_ERRMSG, WC_NONE, 0, _nested_errmsg_widgets, lengthof(_nested_errmsg_widgets))
static const NWidgetPart | _nested_errmsg_face_widgets []
static const WindowDesc | _errmsg_face_desc (WDP_MANUAL, 0, 0, WC_ERRMSG, WC_NONE, 0, _nested_errmsg_face_widgets, lengthof(_nested_errmsg_face_widgets))
static const NWidgetPart | _nested_tooltips_widgets []
static const WindowDesc | _tool_tips_desc (WDP_MANUAL, 0, 0, WC_TOOLTIPS, WC_NONE, 0, _nested_tooltips_widgets, lengthof(_nested_tooltips_widgets))
static const NWidgetPart | _nested_query_string_widgets []
static const WindowDesc | _query_string_desc (WDP_AUTO, 0, 0, WC_QUERY_STRING, WC_NONE, 0, _nested_query_string_widgets, lengthof(_nested_query_string_widgets))
static const NWidgetPart | _nested_query_widgets []
static const WindowDesc | _query_desc (WDP_CENTER, 0, 0, WC_CONFIRM_POPUP_QUERY, WC_NONE, WDF_UNCLICK_BUTTONS|WDF_MODAL, _nested_query_widgets, lengthof(_nested_query_widgets))

## Detailed Description

GUIs for a number of misc windows.

Definition in file misc_gui.cpp.

## Enumeration Type Documentation

enum AboutWidgets

Widgets for the land info window.

Enumerator:

  AW_SCROLLING_TEXT | The actually scrolling text.
  AW_WEBSITE | URL of OpenTTD website.

Definition at line 362 of file misc_gui.cpp.

enum LandInfoWidgets

Widgets for the land info window.

Enumerator:

  LIW_BACKGROUND | Background to draw on.

Definition at line 48 of file misc_gui.cpp.

enum QueryStringWidgets

Widget of the string query window.

Definition at line 1354 of file misc_gui.cpp.

## Function Documentation

void DeleteTextBufferAll | ( | Textbuf * | tb | ) |

Delete every character in the textbuffer.

Parameters:

  | tb | Textbuf buffer to be emptied

Definition at line 1025 of file misc_gui.cpp.

References Textbuf::buf, Textbuf::bytes, Textbuf::caretpos, Textbuf::caretxoffs, Textbuf::chars, Textbuf::max_bytes, and Textbuf::pixels.

Referenced by IConsoleWindow::OnKeyPress().

bool DeleteTextBufferChar | ( | Textbuf * | tb,
|  | int | delmode |
| ) |  |  |

Delete a character from a textbuffer, either with 'Delete' or 'Backspace' The character is delete from the position the caret is at.

Parameters:

  | tb | Textbuf type to be changed
  | delmode | Type of deletion, either WKC_BACKSPACE or WKC_DELETE

Returns:
  Return true on successful change of Textbuf, or false otherwise

Definition at line 1008 of file misc_gui.cpp.

References Textbuf::bytes, and Textbuf::caretpos.

Referenced by OskWindow::OnClick(), and IConsoleWindow::OnKeyPress().

bool GetClipboardContents | ( | char * | buffer,
|  | size_t | buff_len |
| ) |  |  |

Try to retrive the current clipboard contents.

Note:
  OS-specific funtion.

Returns:
  True if some text could be retrived.

Definition at line 178 of file os2.cpp.

References convert_from_fs(), FS2OTTD(), and ttd_strlcpy().

Referenced by InsertTextBufferClipboard().

void GuiShowTooltips | ( | Window * | parent,
|  | StringID | str,
|  | uint | paramcount,
|  | const uint64 | params[],
|  | TooltipCloseCondition | close_tooltip |
| ) |  |  |

Shows a tooltip.

Parameters:

  | parent | The window this tooltip is related to.
  | str | String to be displayed
  | paramcount | number of params to deal with
  | params | (optional) up to 5 pieces of additional information that may be added to a tooltip
  | use_left_mouse_button | close the tooltip when the left (true) or right (false) mousebutton is released

Definition at line 967 of file misc_gui.cpp.

References DeleteWindowById().

Referenced by DispatchHoverEvent(), DispatchRightClickEvent(), IndustryCargoesWindow::OnHover(), DepotWindow::OnRightClick(), and ShowMeasurementTooltips().

void HideFillingPercent | ( | TextEffectID * | te_id | ) |

Hide vehicle loading indicators.

Parameters:

  | *te_id | TextEffectID which is supposed to be hidden.

Definition at line 854 of file misc_gui.cpp.

Referenced by CmdReverseTrainDirection(), Train::Crash(), Vehicle::LeaveStation(), and Vehicle::PreDestructor().

void InitializeTextBuffer | ( | Textbuf * | tb,
|  | char * | buf,
|  | uint16 | max_bytes,
|  | uint16 | max_chars,
|  | uint16 | max_pixels |
| ) |  |  |

Initialize the textbuffer by supplying it the buffer to write into and the maximum length of this buffer.

Parameters:

  | tb | Textbuf type which is getting initialized
  | buf | the buffer that will be holding the data for input
  | max_bytes | maximum size in bytes, including terminating ''
  | max_chars | maximum size in chars, including terminating ''
  | max_pixels | maximum length in pixels of this buffer. If reached, buffer cannot grow, even if maxsize would allow because there is space. Width of zero '0' means the buffer is only restricted by maxsize

Definition at line 1181 of file misc_gui.cpp.

References Textbuf::buf, Textbuf::caret, Textbuf::max_bytes, Textbuf::max_chars, Textbuf::max_pixels, and UpdateTextBufferSize().

void InitializeTextBuffer | ( | Textbuf * | tb,
|  | char * | buf,
|  | uint16 | max_bytes,
|  | uint16 | max_pixels |
| ) |  |  |

Initialize the textbuffer by supplying it the buffer to write into and the maximum length of this buffer.

Parameters:

  | tb | Textbuf type which is getting initialized
  | buf | the buffer that will be holding the data for input
  | max_bytes | maximum size in bytes, including terminating ''
  | max_pixels | maximum length in pixels of this buffer. If reached, buffer cannot grow, even if maxsize would allow because there is space. Width of zero '0' means the buffer is only restricted by maxsize

Definition at line 1165 of file misc_gui.cpp.

References InitializeTextBuffer().

Referenced by InitializeTextBuffer(), and NetworkContentListWindow::NetworkContentListWindow().

bool InsertTextBufferChar | ( | Textbuf * | tb,
|  | WChar | key |
| ) |  |  |

Insert a character to a textbuffer.

If maxwidth of the Textbuf is zero, we don't care about the visual-length but only about the physical length of the string

Parameters:

  | tb | Textbuf type to be changed
  | key | Character to be inserted

Returns:
  Return true on successful change of Textbuf, or false otherwise

Definition at line 1040 of file misc_gui.cpp.

References Textbuf::buf, Textbuf::bytes, Textbuf::caretpos, Textbuf::caretxoffs, Textbuf::chars, FS_NORMAL, GetCharacterWidth(), Textbuf::max_chars, Textbuf::max_pixels, Textbuf::pixels, Utf8CharLen(), and Utf8Encode().

Referenced by OskWindow::OnClick(), and IConsoleWindow::OnKeyPress().

bool InsertTextBufferClipboard | ( | Textbuf * | tb | ) |

Insert a chunk of text from the clipboard onto the textbuffer.

Get TEXT clipboard and append this up to the maximum length (either absolute or screenlength). If maxlength is zero, we don't care about the screenlength but only about the physical length of the string

Parameters:

  | tb | Textbuf type to be changed

Returns:
  true on successful change of Textbuf, or false otherwise

Definition at line 1065 of file misc_gui.cpp.

References Textbuf::buf, Textbuf::bytes, Textbuf::caretpos, Textbuf::caretxoffs, Textbuf::chars, FS_NORMAL, GetCharacterWidth(), GetClipboardContents(), lengthof, Textbuf::max_bytes, Textbuf::max_chars, Textbuf::max_pixels, Textbuf::pixels, and Utf8CharLen().

Referenced by IConsoleWindow::OnKeyPress().

bool MoveTextBufferPos | ( | Textbuf * | tb,
|  | int | navmode |
| ) |  |  |

Handle text navigation with arrow keys left/right.

This defines where the caret will blink and the next characer interaction will occur

Parameters:

  | tb | Textbuf type where navigation occurs
  | navmode | Direction in which navigation occurs WKC_LEFT, WKC_RIGHT, WKC_END, WKC_HOME

Returns:
  Return true on successful change of Textbuf, or false otherwise

Definition at line 1112 of file misc_gui.cpp.

References Textbuf::buf, Textbuf::bytes, Textbuf::caretpos, Textbuf::caretxoffs, FS_NORMAL, GetCharacterWidth(), Textbuf::pixels, Utf8Decode(), and Utf8PrevChar().

Referenced by OskWindow::OnClick(), and IConsoleWindow::OnKeyPress().

void ShowCostOrIncomeAnimation | ( | int | x,
|  | int | y,
|  | int | z,
|  | Money | cost |
| ) |  |  |

Display animated income or costs on the map.

Parameters:

  | x | World X position of the animation location.
  | y | World Y position of the animation location.
  | z | World Z position of the animation location.
  | cost | Estimated cost (or income if negative).

Definition at line 790 of file misc_gui.cpp.

References DAY_TICKS, RemapCoords(), SetDParam(), and TE_RISING.

Referenced by DoCommandP(), and VehicleEnterDepot().

void ShowErrorMessage | ( | StringID | summary_msg,
|  | StringID | detailed_msg,
|  | WarningLevel | wl,
|  | int | x,
|  | int | y |
| ) |  |  |

Display an error message in a window.

Parameters:

  | summary_msg | General error message showed in first line. Must be valid.
  | detailed_msg | Detailed error message showed in second line. Can be INVALID_STRING_ID.
  | wl | Message severity.
  | x | World X position (TileVirtX) of the error location. Set both x and y to 0 to just center the message when there is no related error tile.
  | y | World Y position (TileVirtY) of the error location. Set both x and y to 0 to just center the message when there is no related error tile.

Definition at line 737 of file misc_gui.cpp.

References _settings_client, CC_WARNING, DeleteWindowById(), DRAW_STRING_BUFFER, GUISettings::errmsg_duration, ClientSettings::gui, IConsoleError(), IConsolePrint(), INVALID_STRING_ID, lastof, seprintf(), WL_CRITICAL, WL_INFO, and WL_WARNING.

Referenced by ClientNetworkContentSocketHandler::AfterDownload(), ClientNetworkContentSocketHandler::BeforeDownload(), CcBuildIndustry(), ChangeDynamicEngines(), ClientNetworkGameSocketHandler::CheckConnection(), CheckForMissingGlyphsInLoadedLanguagePack(), CheckForMissingSprites(), CheckTrainsLengths(), AIInstance::Died(), DoAutosave(), DoCommandP(), IndustryProductionCallback(), MakeScreenshot(), FoundTownWindow::OnClick(), TownViewWindow::OnClick(), GameDifficultyWindow::OnClick(), GameOptionsWindow::OnClick(), NewGRFWindow::OnClick(), SelectGameWindow::OnClick(), BuildIndustryWindow::OnClick(), SaveLoadWindow::OnClick(), SelectCompanyManagerFaceWindow::OnClick(), AIConfigWindow::OnClick(), NetworkContentListWindow::OnConnect(), BuildIndustryWindow::OnPlaceObject(), SelectCompanyManagerFaceWindow::OnQueryTextFinished(), SaveLoadWindow::OnTimeout(), ReadHeightmapBMP(), ReadHeightmapPNG(), SaveFileError(), SaveOrLoad(), ShowAIDebugWindow(), ShowBuildBridgeWindow(), ShowEstimatedCostOrIncome(), ShowNetworkContentListWindow(), ShowNewGRFError(), ShowNewGrfVehicleError(), and WarnCorruptSprite().

void ShowEstimatedCostOrIncome | ( | Money | cost,
|  | int | x,
|  | int | y |
| ) |  |  |

Display estimated costs.

Parameters:

  | cost | Estimated cost (or income if negative).
  | x | X position of the notification window.
  | y | Y position of the notification window.

Definition at line 771 of file misc_gui.cpp.

References INVALID_STRING_ID, SetDParam(), ShowErrorMessage(), and WL_INFO.

Referenced by DoCommandP().

void ShowFeederIncomeAnimation | ( | int | x,
|  | int | y,
|  | int | z,
|  | Money | cost |
| ) |  |  |

Display animated feeder income.

Parameters:

  | x | World X position of the animation location.
  | y | World Y position of the animation location.
  | z | World Z position of the animation location.
  | cost | Estimated feeder income.

Definition at line 810 of file misc_gui.cpp.

References DAY_TICKS, RemapCoords(), SetDParam(), and TE_RISING.

TextEffectID ShowFillingPercent | ( | int | x,
|  | int | y,
|  | int | z,
|  | uint8 | percent,
|  | StringID | string |
| ) |  |  |

Display vehicle loading indicators.

Parameters:

  | x | World X position of the animation location.
  | y | World Y position of the animation location.
  | z | World Z position of the animation location.
  | percent | Estimated feeder income.
  | string | String which is drawn on the map.

Returns:
  TextEffectID to be used for future updates of the loading indicators.

Definition at line 827 of file misc_gui.cpp.

References RemapCoords(), SetDParam(), and TE_STATIC.

Referenced by LoadUnloadVehicle().

void ShowLandInfo | ( | TileIndex | tile | ) |

Show land information window.

Parameters:

  | tile | The tile to show information about.

Definition at line 355 of file misc_gui.cpp.

References DeleteWindowById().

Referenced by ScenarioEditorToolbarWindow::OnPlaceObject(), and MainToolbarWindow::OnPlaceObject().

void ShowQuery | ( | StringID | caption,
|  | StringID | message,
|  | Window * | parent,
|  | QueryCallbackProc * | callback |
| ) |  |  |

Show a modal confirmation window with standard 'yes' and 'no' buttons The window is aligned to the centre of its parent.

Parameters:

  | caption | string shown as window caption
  | message | string that will be shown for the window
  | parent | pointer to parent window, if this pointer is NULL the parent becomes the main window WC_MAIN_WINDOW
  | callback | callback function pointer to set in the window descriptor

Definition at line 1663 of file misc_gui.cpp.

References FindWindowById(), Window::parent, QueryWindow::proc, and Window::window_class.

Referenced by CmdPause(), ScenarioEditorLandscapeGenerationWindow::OnClick(), NewGRFWindow::OnClick(), GenerateProgressWindow::OnClick(), GenerateLandscapeWindow::OnClick(), and DepotWindow::OnClick().

void ShowQueryString | ( | StringID | str,
|  | StringID | caption,
|  | uint | maxsize,
|  | uint | maxwidth,
|  | Window * | parent,
|  | CharSetFilter | afilter,
|  | QueryStringFlags | flags |
| ) |  |  |

Show a query popup window with a textbox in it.

Parameters:

  | str | StringID for the text shown in the textbox
  | caption | StringID of text shown in caption of querywindow
  | maxsize | maximum size in bytes or characters (including terminating '') depending on flags
  | maxwidth | maximum width in pixels allowed
  | parent | pointer to a Window that will handle the events (ok/cancel) of this window. If NULL, results are handled by global function HandleOnEditText
  | afilter | filters out unwanted character input
  | flags | various flags,

See also:
  QueryStringFlags

Definition at line 1516 of file misc_gui.cpp.

References DeleteWindowById(), MAX_CHAR_LENGTH, and QSF_LEN_IN_CHARS.

Referenced by WaypointWindow::OnClick(), VehicleDetailsWindow::OnClick(), TownViewWindow::OnClick(), TimetableWindow::OnClick(), StationViewWindow::OnClick(), CustomCurrencyWindow::OnClick(), GameSettingsWindow::OnClick(), OrdersWindow::OnClick(), NewGRFWindow::OnClick(), NewGRFParametersWindow::OnClick(), SpriteAlignerWindow::OnClick(), NetworkStartServerWindow::OnClick(), NetworkGameWindow::OnClick(), IndustryViewWindow::OnClick(), CreateScenarioWindow::OnClick(), GenerateLandscapeWindow::OnClick(), DepotWindow::OnClick(), CompanyWindow::OnClick(), SelectCompanyManagerFaceWindow::OnClick(), CheatWindow::OnClick(), BuildVehicleWindow::OnClick(), AISettingsWindow::OnClick(), GenerateLandscapeWindow::OnDropdownSelect(), and ToolbarScenDatePanel().

void UpdateFillingPercent | ( | TextEffectID | te_id,
|  | uint8 | percent,
|  | StringID | string |
| ) |  |  |

Update vehicle loading indicators.

Parameters:

  | te_id | TextEffectID to be updated.
  | string | String wich is printed.

Definition at line 842 of file misc_gui.cpp.

References SetDParam().

Referenced by LoadUnloadVehicle().

void UpdateTextBufferSize | ( | Textbuf * | tb | ) |

Update Textbuf type with its actual physical character and screenlength Get the count of characters in the string as well as the width in pixels.

Useful when copying in a larger amount of text at once

Parameters:

  | tb | Textbuf type which length is calculated

Definition at line 1200 of file misc_gui.cpp.

References Textbuf::buf, Textbuf::bytes, Textbuf::caretpos, Textbuf::caretxoffs, Textbuf::chars, FS_NORMAL, GetCharacterWidth(), Textbuf::max_bytes, Textbuf::max_chars, Textbuf::pixels, and Utf8CharLen().

Referenced by NetworkChatWindow::ChatTabCompletion(), SignListWindow::ClearFilterTextWidget(), IConsoleHistoryNavigate(), InitializeTextBuffer(), OskWindow::OnClick(), GenerateLandscapeWindow::OnClick(), SaveLoadWindow::OnClick(), and SaveLoadWindow::OnTimeout().

## Variable Documentation

const NWidgetPart _nested_about_widgets[]`[static]`

Initial value:

     {
      NWidget(NWID_HORIZONTAL),
        NWidget(WWT_CLOSEBOX, COLOUR_GREY),
        NWidget(WWT_CAPTION, COLOUR_GREY), SetDataTip(STR_ABOUT_OPENTTD, STR_TOOLTIP_WINDOW_TITLE_DRAG_THIS),
      EndContainer(),
      NWidget(WWT_PANEL, COLOUR_GREY), SetPIP(4, 2, 4),
        NWidget(WWT_LABEL, COLOUR_GREY), SetDataTip(STR_ABOUT_ORIGINAL_COPYRIGHT, STR_NULL),
        NWidget(WWT_LABEL, COLOUR_GREY), SetDataTip(STR_ABOUT_VERSION, STR_NULL),
        NWidget(WWT_FRAME, COLOUR_GREY), SetPadding(0, 5, 1, 5),
          NWidget(WWT_EMPTY, INVALID_COLOUR, AW_SCROLLING_TEXT),
        EndContainer(),
        NWidget(WWT_LABEL, COLOUR_GREY, AW_WEBSITE), SetDataTip(STR_BLACK_RAW_STRING, STR_NULL),
        NWidget(WWT_LABEL, COLOUR_GREY), SetDataTip(STR_ABOUT_COPYRIGHT_OPENTTD, STR_NULL),
      EndContainer(),
    }

Definition at line 367 of file misc_gui.cpp.

const NWidgetPart _nested_errmsg_face_widgets[]`[static]`

Initial value:

     {
      NWidget(NWID_HORIZONTAL),
        NWidget(WWT_CLOSEBOX, COLOUR_RED),
        NWidget(WWT_CAPTION, COLOUR_RED, EMW_CAPTION), SetDataTip(STR_ERROR_MESSAGE_CAPTION_OTHER_COMPANY, STR_NULL),
      EndContainer(),
      NWidget(WWT_PANEL, COLOUR_RED),
        NWidget(NWID_HORIZONTAL), SetPIP(2, 1, 2),
          NWidget(WWT_EMPTY, COLOUR_RED, EMW_FACE), SetMinimalSize(92, 119), SetFill(0, 1), SetPadding(2, 0, 1, 0),
          NWidget(WWT_EMPTY, COLOUR_RED, EMW_MESSAGE), SetFill(0, 1), SetMinimalSize(238, 123),
        EndContainer(),
      EndContainer(),
    }

Definition at line 543 of file misc_gui.cpp.

const NWidgetPart _nested_errmsg_widgets[]`[static]`

Initial value:

     {
      NWidget(NWID_HORIZONTAL),
        NWidget(WWT_CLOSEBOX, COLOUR_RED),
        NWidget(WWT_CAPTION, COLOUR_RED, EMW_CAPTION), SetDataTip(STR_ERROR_MESSAGE_CAPTION, STR_NULL),
      EndContainer(),
      NWidget(WWT_PANEL, COLOUR_RED),
        NWidget(WWT_EMPTY, COLOUR_RED, EMW_MESSAGE), SetPadding(0, 2, 0, 2), SetMinimalSize(236, 32),
      EndContainer(),
    }

Definition at line 526 of file misc_gui.cpp.

const NWidgetPart _nested_land_info_widgets[]`[static]`

Initial value:

     {
      NWidget(NWID_HORIZONTAL),
        NWidget(WWT_CLOSEBOX, COLOUR_GREY),
        NWidget(WWT_CAPTION, COLOUR_GREY), SetDataTip(STR_LAND_AREA_INFORMATION_CAPTION, STR_TOOLTIP_WINDOW_TITLE_DRAG_THIS),
        NWidget(WWT_DEBUGBOX, COLOUR_GREY),
      EndContainer(),
      NWidget(WWT_PANEL, COLOUR_GREY, LIW_BACKGROUND), EndContainer(),
    }

Definition at line 52 of file misc_gui.cpp.

const NWidgetPart _nested_query_string_widgets[]`[static]`

Initial value:

     {
      NWidget(NWID_HORIZONTAL),
        NWidget(WWT_CLOSEBOX, COLOUR_GREY),
        NWidget(WWT_CAPTION, COLOUR_GREY, QUERY_STR_WIDGET_CAPTION), SetDataTip(STR_WHITE_STRING, STR_NULL),
      EndContainer(),
      NWidget(WWT_PANEL, COLOUR_GREY),
        NWidget(WWT_EDITBOX, COLOUR_GREY, QUERY_STR_WIDGET_TEXT), SetMinimalSize(256, 12), SetFill(1, 1), SetPadding(2, 2, 2, 2),
      EndContainer(),
      NWidget(NWID_HORIZONTAL, NC_EQUALSIZE),
        NWidget(WWT_TEXTBTN, COLOUR_GREY, QUERY_STR_WIDGET_DEFAULT), SetMinimalSize(87, 12), SetFill(1, 1), SetDataTip(STR_BUTTON_DEFAULT, STR_NULL),
        NWidget(WWT_TEXTBTN, COLOUR_GREY, QUERY_STR_WIDGET_CANCEL), SetMinimalSize(86, 12), SetFill(1, 1), SetDataTip(STR_BUTTON_CANCEL, STR_NULL),
        NWidget(WWT_TEXTBTN, COLOUR_GREY, QUERY_STR_WIDGET_OK), SetMinimalSize(87, 12), SetFill(1, 1), SetDataTip(STR_BUTTON_OK, STR_NULL),
      EndContainer(),
    }

Definition at line 1483 of file misc_gui.cpp.

const NWidgetPart _nested_query_widgets[]`[static]`

Initial value:

     {
      NWidget(NWID_HORIZONTAL),
        NWidget(WWT_CLOSEBOX, COLOUR_RED),
        NWidget(WWT_CAPTION, COLOUR_RED, QUERY_WIDGET_CAPTION), SetDataTip(STR_JUST_STRING, STR_NULL),
      EndContainer(),
      NWidget(WWT_PANEL, COLOUR_RED), SetPIP(8, 15, 8),
        NWidget(WWT_TEXT, COLOUR_RED, QUERY_WIDGET_TEXT), SetMinimalSize(200, 12),
        NWidget(NWID_HORIZONTAL, NC_EQUALSIZE), SetPIP(20, 29, 20),
          NWidget(WWT_PUSHTXTBTN, COLOUR_YELLOW, QUERY_WIDGET_NO), SetMinimalSize(71, 12), SetDataTip(STR_QUIT_NO, STR_NULL),
          NWidget(WWT_PUSHTXTBTN, COLOUR_YELLOW, QUERY_WIDGET_YES), SetMinimalSize(71, 12), SetDataTip(STR_QUIT_YES, STR_NULL),
        EndContainer(),
      EndContainer(),
    }

Definition at line 1633 of file misc_gui.cpp.

const NWidgetPart _nested_tooltips_widgets[]`[static]`

Initial value:

     {
      NWidget(WWT_PANEL, COLOUR_GREY, 0), SetMinimalSize(200, 32), EndContainer(),
    }

Definition at line 862 of file misc_gui.cpp.